# coding: utf-8

"""
    Catapult REST Endpoints

    OpenAPI Specification of catapult-rest

    The version of the OpenAPI document: 1.0.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AggregateNetworkPropertiesDTO(BaseModel):
    """
    AggregateNetworkPropertiesDTO
    """ # noqa: E501
    max_transactions_per_aggregate: Optional[StrictStr] = Field(default=None, description="Maximum number of transactions per aggregate.", alias="maxTransactionsPerAggregate")
    max_cosignatures_per_aggregate: Optional[StrictStr] = Field(default=None, description="Maximum number of cosignatures per aggregate.", alias="maxCosignaturesPerAggregate")
    enable_strict_cosignature_check: Optional[StrictBool] = Field(default=None, description="Set to true if cosignatures must exactly match component signers. Set to false if cosignatures should be validated externally.", alias="enableStrictCosignatureCheck")
    enable_bonded_aggregate_support: Optional[StrictBool] = Field(default=None, description="Set to true if bonded aggregates should be allowed. Set to false if bonded aggregates should be rejected.", alias="enableBondedAggregateSupport")
    max_bonded_transaction_lifetime: Optional[StrictStr] = Field(default=None, description="Maximum lifetime a bonded transaction can have before it expires.", alias="maxBondedTransactionLifetime")
    __properties: ClassVar[List[str]] = ["maxTransactionsPerAggregate", "maxCosignaturesPerAggregate", "enableStrictCosignatureCheck", "enableBondedAggregateSupport", "maxBondedTransactionLifetime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AggregateNetworkPropertiesDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AggregateNetworkPropertiesDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "maxTransactionsPerAggregate": obj.get("maxTransactionsPerAggregate"),
            "maxCosignaturesPerAggregate": obj.get("maxCosignaturesPerAggregate"),
            "enableStrictCosignatureCheck": obj.get("enableStrictCosignatureCheck"),
            "enableBondedAggregateSupport": obj.get("enableBondedAggregateSupport"),
            "maxBondedTransactionLifetime": obj.get("maxBondedTransactionLifetime")
        })
        return _obj


