# coding: utf-8

"""
    Catapult REST Endpoints

    OpenAPI Specification of catapult-rest

    The version of the OpenAPI document: 1.0.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from mijin_openapi_client.models.network_type_enum import NetworkTypeEnum
from typing import Optional, Set
from typing_extensions import Self

class BlockDTO(BaseModel):
    """
    BlockDTO
    """ # noqa: E501
    size: StrictInt = Field(description="A number that allows uint 32 values.")
    signature: StrictStr = Field(description="Entity's signature generated by the signer.")
    signer_public_key: StrictStr = Field(description="Public key.", alias="signerPublicKey")
    version: StrictInt = Field(description="Entity version.")
    network: NetworkTypeEnum
    type: StrictInt
    height: StrictStr = Field(description="Height of the blockchain.")
    timestamp: StrictStr = Field(description="Number of milliseconds elapsed since the creation of the nemesis block. This value can be converted to epoch time by adding the network's 'epochAdjustment'.")
    difficulty: StrictStr = Field(description="Determines how hard is to harvest a new block, based on previous blocks.")
    proof_gamma: StrictStr = Field(description="32-bytes VRF proof gamma.", alias="proofGamma")
    proof_verification_hash: StrictStr = Field(description="16-bytes VRF proof verification hash.", alias="proofVerificationHash")
    proof_scalar: StrictStr = Field(description="32-bytes VRF proof scalar.", alias="proofScalar")
    previous_block_hash: StrictStr = Field(alias="previousBlockHash")
    transactions_hash: StrictStr = Field(alias="transactionsHash")
    receipts_hash: StrictStr = Field(alias="receiptsHash")
    state_hash: StrictStr = Field(alias="stateHash")
    beneficiary_address: StrictStr = Field(description="Address encoded using a 32-character set.", alias="beneficiaryAddress")
    fee_multiplier: StrictInt = Field(description="Fee multiplier applied to transactions contained in block.", alias="feeMultiplier")
    __properties: ClassVar[List[str]] = ["size", "signature", "signerPublicKey", "version", "network", "type", "height", "timestamp", "difficulty", "proofGamma", "proofVerificationHash", "proofScalar", "previousBlockHash", "transactionsHash", "receiptsHash", "stateHash", "beneficiaryAddress", "feeMultiplier"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BlockDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BlockDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "size": obj.get("size"),
            "signature": obj.get("signature"),
            "signerPublicKey": obj.get("signerPublicKey"),
            "version": obj.get("version"),
            "network": obj.get("network"),
            "type": obj.get("type"),
            "height": obj.get("height"),
            "timestamp": obj.get("timestamp"),
            "difficulty": obj.get("difficulty"),
            "proofGamma": obj.get("proofGamma"),
            "proofVerificationHash": obj.get("proofVerificationHash"),
            "proofScalar": obj.get("proofScalar"),
            "previousBlockHash": obj.get("previousBlockHash"),
            "transactionsHash": obj.get("transactionsHash"),
            "receiptsHash": obj.get("receiptsHash"),
            "stateHash": obj.get("stateHash"),
            "beneficiaryAddress": obj.get("beneficiaryAddress"),
            "feeMultiplier": obj.get("feeMultiplier")
        })
        return _obj


