# coding: utf-8

"""
    Catapult REST Endpoints

    OpenAPI Specification of catapult-rest

    The version of the OpenAPI document: 1.0.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from mijin_openapi_client.models.namespace_registration_type_enum import NamespaceRegistrationTypeEnum
from mijin_openapi_client.models.network_type_enum import NetworkTypeEnum
from typing import Optional, Set
from typing_extensions import Self

class EmbeddedNamespaceRegistrationTransactionDTO(BaseModel):
    """
    EmbeddedNamespaceRegistrationTransactionDTO
    """ # noqa: E501
    signer_public_key: StrictStr = Field(description="Public key.", alias="signerPublicKey")
    version: StrictInt = Field(description="Entity version.")
    network: NetworkTypeEnum
    type: StrictInt
    duration: Optional[StrictStr] = Field(default=None, description="Duration expressed in number of blocks.")
    parent_id: Optional[StrictStr] = Field(default=None, description="Namespace identifier.", alias="parentId")
    id: StrictStr = Field(description="Namespace identifier.")
    registration_type: NamespaceRegistrationTypeEnum = Field(alias="registrationType")
    name: StrictStr = Field(description="Namespace name.")
    __properties: ClassVar[List[str]] = ["signerPublicKey", "version", "network", "type", "duration", "parentId", "id", "registrationType", "name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EmbeddedNamespaceRegistrationTransactionDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EmbeddedNamespaceRegistrationTransactionDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "signerPublicKey": obj.get("signerPublicKey"),
            "version": obj.get("version"),
            "network": obj.get("network"),
            "type": obj.get("type"),
            "duration": obj.get("duration"),
            "parentId": obj.get("parentId"),
            "id": obj.get("id"),
            "registrationType": obj.get("registrationType"),
            "name": obj.get("name")
        })
        return _obj


