# coding: utf-8

"""
    Catapult REST Endpoints

    OpenAPI Specification of catapult-rest

    The version of the OpenAPI document: 1.0.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from mijin_openapi_client.models.alias_dto import AliasDTO
from mijin_openapi_client.models.namespace_registration_type_enum import NamespaceRegistrationTypeEnum
from typing import Optional, Set
from typing_extensions import Self

class NamespaceDTO(BaseModel):
    """
    NamespaceDTO
    """ # noqa: E501
    version: StrictInt = Field(description="The version of the state")
    registration_type: NamespaceRegistrationTypeEnum = Field(alias="registrationType")
    depth: StrictInt = Field(description="Level of the namespace.")
    level0: StrictStr = Field(description="Namespace identifier.")
    level1: Optional[StrictStr] = Field(default=None, description="Namespace identifier.")
    level2: Optional[StrictStr] = Field(default=None, description="Namespace identifier.")
    alias: AliasDTO
    parent_id: StrictStr = Field(description="Namespace identifier.", alias="parentId")
    owner_address: StrictStr = Field(description="Address encoded using a 32-character set.", alias="ownerAddress")
    start_height: StrictStr = Field(description="Height of the blockchain.", alias="startHeight")
    end_height: StrictStr = Field(description="Height of the blockchain.", alias="endHeight")
    __properties: ClassVar[List[str]] = ["version", "registrationType", "depth", "level0", "level1", "level2", "alias", "parentId", "ownerAddress", "startHeight", "endHeight"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NamespaceDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of alias
        if self.alias:
            _dict['alias'] = self.alias.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NamespaceDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "version": obj.get("version"),
            "registrationType": obj.get("registrationType"),
            "depth": obj.get("depth"),
            "level0": obj.get("level0"),
            "level1": obj.get("level1"),
            "level2": obj.get("level2"),
            "alias": AliasDTO.from_dict(obj["alias"]) if obj.get("alias") is not None else None,
            "parentId": obj.get("parentId"),
            "ownerAddress": obj.get("ownerAddress"),
            "startHeight": obj.get("startHeight"),
            "endHeight": obj.get("endHeight")
        })
        return _obj


