# coding: utf-8

"""
    Catapult REST Endpoints

    OpenAPI Specification of catapult-rest

    The version of the OpenAPI document: 1.0.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List
from mijin_openapi_client.models.chain_properties_dto import ChainPropertiesDTO
from mijin_openapi_client.models.network_properties_dto import NetworkPropertiesDTO
from mijin_openapi_client.models.plugins_properties_dto import PluginsPropertiesDTO
from typing import Optional, Set
from typing_extensions import Self

class NetworkConfigurationDTO(BaseModel):
    """
    NetworkConfigurationDTO
    """ # noqa: E501
    network: NetworkPropertiesDTO
    chain: ChainPropertiesDTO
    plugins: PluginsPropertiesDTO
    __properties: ClassVar[List[str]] = ["network", "chain", "plugins"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NetworkConfigurationDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of network
        if self.network:
            _dict['network'] = self.network.to_dict()
        # override the default output from pydantic by calling `to_dict()` of chain
        if self.chain:
            _dict['chain'] = self.chain.to_dict()
        # override the default output from pydantic by calling `to_dict()` of plugins
        if self.plugins:
            _dict['plugins'] = self.plugins.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NetworkConfigurationDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "network": NetworkPropertiesDTO.from_dict(obj["network"]) if obj.get("network") is not None else None,
            "chain": ChainPropertiesDTO.from_dict(obj["chain"]) if obj.get("chain") is not None else None,
            "plugins": PluginsPropertiesDTO.from_dict(obj["plugins"]) if obj.get("plugins") is not None else None
        })
        return _obj


