# coding: utf-8

"""
    Catapult REST Endpoints

    OpenAPI Specification of catapult-rest

    The version of the OpenAPI document: 1.0.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from mijin_openapi_client.models.source_dto import SourceDTO
from mijin_openapi_client.models.transaction_statement_dto_receipts_inner import TransactionStatementDTOReceiptsInner
from typing import Optional, Set
from typing_extensions import Self

class TransactionStatementDTO(BaseModel):
    """
    TransactionStatementDTO
    """ # noqa: E501
    height: StrictStr = Field(description="Height of the blockchain.")
    source: SourceDTO
    receipts: List[TransactionStatementDTOReceiptsInner] = Field(description="Array of receipts.")
    __properties: ClassVar[List[str]] = ["height", "source", "receipts"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransactionStatementDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of source
        if self.source:
            _dict['source'] = self.source.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in receipts (list)
        _items = []
        if self.receipts:
            for _item_receipts in self.receipts:
                if _item_receipts:
                    _items.append(_item_receipts.to_dict())
            _dict['receipts'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransactionStatementDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "height": obj.get("height"),
            "source": SourceDTO.from_dict(obj["source"]) if obj.get("source") is not None else None,
            "receipts": [TransactionStatementDTOReceiptsInner.from_dict(_item) for _item in obj["receipts"]] if obj.get("receipts") is not None else None
        })
        return _obj


