# coding: utf-8

"""
    Catapult REST Endpoints

    OpenAPI Specification of catapult-rest

    The version of the OpenAPI document: 1.0.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Optional
from mijin_openapi_client.models.balance_change_receipt_dto import BalanceChangeReceiptDTO
from mijin_openapi_client.models.balance_transfer_receipt_dto import BalanceTransferReceiptDTO
from mijin_openapi_client.models.inflation_receipt_dto import InflationReceiptDTO
from mijin_openapi_client.models.mosaic_expiry_receipt_dto import MosaicExpiryReceiptDTO
from mijin_openapi_client.models.namespace_expiry_receipt_dto import NamespaceExpiryReceiptDTO
from typing import Union, Any, List, Set, TYPE_CHECKING, Optional, Dict
from typing_extensions import Literal, Self
from pydantic import Field

TRANSACTIONSTATEMENTDTORECEIPTSINNER_ANY_OF_SCHEMAS = ["BalanceChangeReceiptDTO", "BalanceTransferReceiptDTO", "InflationReceiptDTO", "MosaicExpiryReceiptDTO", "NamespaceExpiryReceiptDTO"]

class TransactionStatementDTOReceiptsInner(BaseModel):
    """
    TransactionStatementDTOReceiptsInner
    """

    # data type: BalanceTransferReceiptDTO
    anyof_schema_1_validator: Optional[BalanceTransferReceiptDTO] = None
    # data type: BalanceChangeReceiptDTO
    anyof_schema_2_validator: Optional[BalanceChangeReceiptDTO] = None
    # data type: NamespaceExpiryReceiptDTO
    anyof_schema_3_validator: Optional[NamespaceExpiryReceiptDTO] = None
    # data type: MosaicExpiryReceiptDTO
    anyof_schema_4_validator: Optional[MosaicExpiryReceiptDTO] = None
    # data type: InflationReceiptDTO
    anyof_schema_5_validator: Optional[InflationReceiptDTO] = None
    if TYPE_CHECKING:
        actual_instance: Optional[Union[BalanceChangeReceiptDTO, BalanceTransferReceiptDTO, InflationReceiptDTO, MosaicExpiryReceiptDTO, NamespaceExpiryReceiptDTO]] = None
    else:
        actual_instance: Any = None
    any_of_schemas: Set[str] = { "BalanceChangeReceiptDTO", "BalanceTransferReceiptDTO", "InflationReceiptDTO", "MosaicExpiryReceiptDTO", "NamespaceExpiryReceiptDTO" }

    model_config = {
        "validate_assignment": True,
        "protected_namespaces": (),
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = TransactionStatementDTOReceiptsInner.model_construct()
        error_messages = []
        # validate data type: BalanceTransferReceiptDTO
        if not isinstance(v, BalanceTransferReceiptDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BalanceTransferReceiptDTO`")
        else:
            return v

        # validate data type: BalanceChangeReceiptDTO
        if not isinstance(v, BalanceChangeReceiptDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BalanceChangeReceiptDTO`")
        else:
            return v

        # validate data type: NamespaceExpiryReceiptDTO
        if not isinstance(v, NamespaceExpiryReceiptDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NamespaceExpiryReceiptDTO`")
        else:
            return v

        # validate data type: MosaicExpiryReceiptDTO
        if not isinstance(v, MosaicExpiryReceiptDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MosaicExpiryReceiptDTO`")
        else:
            return v

        # validate data type: InflationReceiptDTO
        if not isinstance(v, InflationReceiptDTO):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InflationReceiptDTO`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in TransactionStatementDTOReceiptsInner with anyOf schemas: BalanceChangeReceiptDTO, BalanceTransferReceiptDTO, InflationReceiptDTO, MosaicExpiryReceiptDTO, NamespaceExpiryReceiptDTO. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[BalanceTransferReceiptDTO] = None
        try:
            instance.actual_instance = BalanceTransferReceiptDTO.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[BalanceChangeReceiptDTO] = None
        try:
            instance.actual_instance = BalanceChangeReceiptDTO.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[NamespaceExpiryReceiptDTO] = None
        try:
            instance.actual_instance = NamespaceExpiryReceiptDTO.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[MosaicExpiryReceiptDTO] = None
        try:
            instance.actual_instance = MosaicExpiryReceiptDTO.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_5_validator: Optional[InflationReceiptDTO] = None
        try:
            instance.actual_instance = InflationReceiptDTO.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into TransactionStatementDTOReceiptsInner with anyOf schemas: BalanceChangeReceiptDTO, BalanceTransferReceiptDTO, InflationReceiptDTO, MosaicExpiryReceiptDTO, NamespaceExpiryReceiptDTO. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], BalanceChangeReceiptDTO, BalanceTransferReceiptDTO, InflationReceiptDTO, MosaicExpiryReceiptDTO, NamespaceExpiryReceiptDTO]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


